#ifndef _MIGOBJ_
#define _MIGOBJ_

#define MIG_ACCT	0x00000001
#define MIG_FOLD	0x00000002
#define MIG_MSGS	0x00000004
#define MIG_ADDR	0x00000008

#define FOLDID_INBOX	1
#define FOLDID_OUTBOX	2
#define FOLDID_SENT		3
#define FOLDID_TRASH	4

typedef void * (*PFNCREATEACCT)(struct _MigAcct *);
typedef int (*PFNCREATEFOLD)(void *, int, char *, int, int[10], int, int);
typedef char * (*PFNGETFOLDPATH)(void *, int);
typedef int (*PFNADDTOFOLD)(void *, int, char *);
typedef int (*PFNSAVEFOLD)(void *, int);
typedef int (*PFNADDRBOOK)(char *, int, int);
typedef int (*PFNADDTOBOOK)(int, struct _MigAddr *);

typedef struct _MigInfo{
	HINSTANCE hi;		//Set by PMMail...do not set
	char *libname;		//Set this to the name of your library

	BOOL available;		//is your product installed on this machine?
	BOOL mig;			//should the product be migrated by default?
	char *product;		//Set this to the name of the prodcut (including version) found
	char *path;			//Set this to the path where the product is installed
	ULONG infofound;	//Or (|) the MIG_ constants together to define what info is available
	ULONG infomig;		//Or (|) the MIG_ constants together to define what info should be migrated
	void *userdata;		//This is for library defined data

	char *author;		//Place your name here
	char *copyright;	//Place a copyright message here
	char *comment;		//Place a comment here
	
	struct _MigInfo *next;	//Set by PMMail...do not set
	BOOL finished;			//Set by PMMail...do not set
} MigInfo, *pMigInfo;

typedef struct _MigAcct{
	char *acctname;		//The account description (text next to the icon)
	char *fromemail;	//The From: e-mail address
	char *fromreal;		//The From: real name
	char *replyemail;	//The Reply-To: e-mail address
	char *replyreal;	//The Reply-To: real name

	int recvsmtp;		//0==receive with POP, 1==receive with SMTP
	char *poprecvserv;	//The POP server name used for fetching
	int poprecvport;	//The port on the POP server to connect to
	char *poprecvid;	//The POP login name
	char *poprecvpass;	//The POP password
	int ignore;			//0==do not ignore messages based on size, 1==ignore messages > size
	int leave;			//0==do not leave all messages on server, 1==to leave messages on server
	int size;			//The size of messages to ignore
	int useservview;	//0==do not receive using Remote Control, 1==to use remote control to receive
	char *smtppath;		//the path where messages can be SMTP received at
	int poll;			//0==do not auto-poll for new mail, 1==poll for new mail
	int interval;		//the interval to poll at

	int sendpop;		//0==Send using POP, 1==send using SMTP
	char *smtpsendserv;	//the SMTP server used for sending
	int smtpsendport;	//the port to connect to on the SMTP send server
	char *popsendserv;	//the POP server used for sending
	int popsendport;	//the port on the POP server to connect to
	char *popsendid;	//the POP login name
	char *popsendpass;	//the POP password
	int saveout;		//0==do not save a copy of outgoing messages, 1==do save a copy
	int wraptype;		//0==no wrap, 1==Reflow, 2==WYSIWYG
	int wraplen;		//Length of line for reflow wrapping
	int html;			//Send mail in HTML format
	int defatttype;		//1==MIME, 2==UUEncode, 3==BinHex
	int safterf;		//0==do not send after fetch, 1==send after fetch

	int viewfull;		//0==do not view the full header of a message by default, 1==do!
	int noquote;		//0==do not quote message text in replies by default, 1==do!
	char *quotepre;		//The quoting string
	int sysbeep;		//0==do not play a system beep on new mail, 1==do!
	int wav;			//0==do not play a wave file on new mail, 1==do!
	char *wavfile;		//The wave file to play
	int passprot;		//0==not password protected, 1==password protected
	char *acctpass;		//the password
	int startopen;		//0==start with the account closed, 1==start open
	int startsend;		//0==do not send pending mail for this account on startup, 1==do!
	int startfetch;		//0==do not fetch this account on startup, 1==do!
	int emptytrash;		//0==do not empty trash on shutdown, 1==do!
	int truedel;		//0==do not perform true deletes, 1==do! (a true delete does not put messages
						//										  in the trash folder).

	int spellalways;	//0==do not auto-spellcheck every outgoing mail, 1==do!
	int skipcaps;		//0==do not skip words in capitals, 1==do!
	int skipquote;		//0==do not skip quoted lines, 1==do!
	int skipnum;		//0==do not skip words containing number, 1==do!

	int askcloprog;		//0==do not confirm closing PMMail, 1==do
	int askclocomp;		//0==do not confirm closing an outgoing message, 1==do
	int askrepatt;		//0==do not confirm attachemnt decode when duplicate filename exists, 1==do
	int promdelmes;		//0==do not confirm message delete, 1==do
	int promdelfold;	//0==do not confirm folder deletion, 1==do (ALWAYS set this to 1)
	int promdelacct;	//0==do not confirm account deletion, 1==do (ALWAYS set this to 1)

	int useext;			//0==use the internal editor, 1==use external editor
	char *editor;		//the full path to the external edit exe file
	char *args;			//arguments to the external editor
	int type;			//not used...for compatibility
	int editcomp;		//use external editor for composing
	int editread;		//use external editor for reading

	int sendexit;		//0==do not use a send hook, 1==do
	int recvexit;		//0==do not use a receive hook, 1==do
	int sendbg;			//0==run send hook in foreground, 1==run it in the background
	int recvbg;			//0==run receive hook in foreground, 1==run it in the background
	char *hooksend;		//executable file to run for the send hook
	char *hookrecv;		//executable file to run for the receive hook
	int custf;			//0==do not use a custom fetch hook, 1==do
	int custs;			//0==do not use a custom send hook, 1==do
	int custfbg;		//0==run custom fetch in foreground, 1==run it in the background
	int custsbg;		//0==run custom send in foreground, 1==run it in the background
	char *hookcustf;	//executable file to run for custom fetch
	char *hookcusts;	//executable file to run for custom send

	int usephrase;		//0==prompt me for my PGP passphrase, 1==use the passphrase variable below
	int remphrase;		//0==forget my passphrase after using it, 1==remember my passphrase for the remainder of the session
	char *passphrase;	//PGP passphrase
	int signall;		//0==don't sign all outgoing messages, 1==do
	int inclpub;		//0==don't include my public key on all outgoing messages, 1==do
	int inclprint;		//0==don't include my public key fingerprint on all outgoing messages, 1==do
	int secwarn;		//0==don't warn me about security issues, 1==do
} MigAcct, *pMigAcct;

typedef struct _MigAddr{
	int group;			//0==this is an address, 1==this is a group

 	char *Alias;		//The alias for this entry
	char *Name;			//The real name (only valid for addresses, not for groups)
	char *EMail;		//The e-mail address (only valid for addresses, not for groups)

	char *Company;		//The company the person works for (only valid for addresses, not for groups)
	char *Title;		//Their title within the company (only valid for addresses, not for groups)
	char *HStreet;		//Their home street address (only valid for addresses, not for groups)
	char *HBuild;		//Their home building (only valid for addresses, not for groups)
	char *HCity;		//Their home city (only valid for addresses, not for groups)
	char *HState;		//Their home state (only valid for addresses, not for groups)
	char *HPC;			//Their home postal code (only valid for addresses, not for groups)
	char *HPhone;		//Their home phone (only valid for addresses, not for groups)
	char *HExt;			//Their home extension (only valid for addresses, not for groups)
	char *HFAX;			//Their home fax number (only valid for addresses, not for groups)
	char *HCountry;		//Their home country (only valid for addresses, not for groups)
	char *BStreet;		//Their work street address (only valid for addresses, not for groups)
	char *BBuild;		//Their work building (only valid for addresses, not for groups)
	char *BCity;		//Their work city (only valid for addresses, not for groups)
	char *BState;		//Their work state (only valid for addresses, not for groups)
	char *BPC;			//Their work postal code (only valid for addresses, not for groups)
	char *BCountry;		//Their work country (only valid for addresses, not for groups)
	char *BPhone;		//Their work phone (only valid for addresses, not for groups)
	char *BExt;			//Their work extension (only valid for addresses, not for groups)
	char *BFAX;			//Their work fax number 

	char *Notes;		//Notes about this user
	char *File;			//File containing group definition (only valid for groups, not for addresses)

	int inpopup;		//0==exclude this address/group from the RMB popup menu, 1==put it in!
} MigAddr, *pMigAddr;

#endif




